Index: LMDZ6/trunk/libf/misc/readTracFiles_mod.f90
===================================================================
--- LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 5184)
+++ LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 5190)
@@ -1152,126 +1199,108 @@
 !=== IF ISOTOPES (2ND GENERATION TRACERS) ARE DETECTED:                                                                     ===
 !===    * COMPUTE MOST OF THE RELATED QUANTITIES ("isot" COMPONENTS).                                                       ===
-!===    * COMPUTE FEW ISOTOPES-DEDICATED "trac" COMPONENTS (defined by "keys(:)")                                           ===
-!===    * CALL readIsotopesFile TO GET PHYSICAL QUANTITIES (<key>=<val> PAIRS)     /!\ DISABLED FUNCTION /!\                ===
-!==============================================================================================================================
-LOGICAL FUNCTION processIsotopes(keys, isot, iClasses) RESULT(lerr)
-  TYPE(keys_type),  TARGET,              OPTIONAL, INTENT(INOUT) ::   keys(:)
-  TYPE(isot_type),  TARGET, ALLOCATABLE, OPTIONAL, INTENT(OUT)   ::   isot(:)
-  CHARACTER(LEN=*), TARGET,              OPTIONAL, INTENT(IN)    :: iClasses(:)
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: str1(:), str2(:)             !--- Temporary storage
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:), parent(:), dType(:), phase(:), gen0N(:), iCla(:)
-  CHARACTER(LEN=maxlen) :: iClass, modname
-  CHARACTER(LEN=1)      :: ph                                        !--- Phase
-  LOGICAL,  ALLOCATABLE :: ll(:)                                     !--- Mask
-  INTEGER,  ALLOCATABLE :: iGen(:)
-  INTEGER :: ic, ip, iq, ii, it, iz
-  TYPE(isot_type), POINTER :: i1
-  TYPE(keys_type), POINTER :: k(:)
+!===    * COMPUTE FEW ISOTOPES-DEDICATED "trac" COMPONENTS                                                                  ===
+!===    * CALL readIsotopesFile TO GET PHYSICAL QUANTITIES (<key>=<val> PAIRS)                                              ===
+!===      NOTE: THIS IS DONE HERE (IN A ROUTINE CALLED BY THE DYNAMIC), BECAUSE THE DYNAMIC NEEDS FEW PHYSICAL PARAMETERS.  ===
+!==============================================================================================================================
+LOGICAL FUNCTION processIsotopes(iNames) RESULT(lerr)
+  CHARACTER(LEN=maxlen), TARGET, OPTIONAL, INTENT(IN)  :: iNames(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: p(:), str(:)                 !--- Temporary storage
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:), parent(:), dType(:), phase(:), gen0N(:)
+  CHARACTER(LEN=maxlen) :: iName, modname
+  CHARACTER(LEN=1)   :: ph                                           !--- Phase
+  INTEGER, ALLOCATABLE ::  iGen(:)
+  INTEGER :: ic, ip, iq, it, iz
+  LOGICAL, ALLOCATABLE :: ll(:)                                      !--- Mask
+  TYPE(trac_type), POINTER   ::  t(:), t1
+  TYPE(isot_type), POINTER   ::  i
 
   lerr = .FALSE.
   modname = 'readIsotopesFile'
-  k => tracers; IF(PRESENT(keys )) k => keys
-  lerr = getKey('name',       tname, k); IF(lerr) RETURN             !--- Names
-  lerr = getKey('parent',    parent, k); IF(lerr) RETURN             !--- Parents
-  lerr = getKey('type',       dType, k); IF(lerr) RETURN             !--- Tracer type
-  lerr = getKey('phase',      phase, k); IF(lerr) RETURN             !--- Phase
-  lerr = getKey('gen0Name',   gen0N, k); IF(lerr) RETURN             !--- 1st generation ancestor name
-  lerr = getKey('iGeneration', iGen, k); IF(lerr) RETURN             !--- Generation number
-
-  !--- INITIALIZATION IF ISOTOPES-SPECIFIC KEYS (MUST BE DEFINED EVEN WITHOUT ISOTOPES)
-  DO iq = 1, SIZE(k)
-    CALL addKey('iso_iGroup',0, k(iq))                               !--- Family       idx in list "isotopes(:)%parent"
-    CALL addKey('iso_iName', 0, k(iq))                               !--- Isotope      idx in effective isotopes list
-    CALL addKey('iso_iZone', 0, k(iq))                               !--- Tagging zone idx in effective zones    list
-    CALL addKey('iso_iPhas', 0, k(iq))                               !--- Phase        idx in effective phases   list
-  END DO
+
+  t => tracers
+
+  lerr = getKey('name',       tname, t%keys); IF(lerr) RETURN       !--- Names
+  lerr = getKey('parent',    parent, t%keys); IF(lerr) RETURN       !--- Parents
+  lerr = getKey('type',       dType, t%keys); IF(lerr) RETURN       !--- Tracer type
+  lerr = getKey('phase',      phase, t%keys); IF(lerr) RETURN       !--- Phase
+  lerr = getKey('gen0Name',   gen0N, t%keys); IF(lerr) RETURN       !--- 1st generation ancestor name
+  lerr = getKey('iGeneration', iGen, t%keys); IF(lerr) RETURN       !--- Generation number
 
   !--- GET FROM "tracers" THE FULL LIST OF AVAILABLE ISOTOPES CLASSES
-  iCla = PACK(delPhase(parent), MASK = dType=='tracer' .AND. iGen==1)
-  CALL strReduce(iCla)
-
-  !--- CHECK WHETHER NEEDED ISOTOPES CLASSES "iClasses" ARE AVAILABLE OR NOT
-  IF(PRESENT(iClasses)) THEN
-    DO it = 1, SIZE(iClasses)
-      lerr = ALL(iCla /= iClasses(it))
-      IF(fmsg('No isotopes class "'//TRIM(iClasses(it))//'" found among tracers', modname, lerr)) RETURN
+  p = PACK(delPhase(parent), MASK = dType=='tracer' .AND. iGen==1)
+  CALL strReduce(p, nbIso)
+
+  !--- CHECK WHETHER NEEDED ISOTOPES CLASSES "iNames" ARE AVAILABLE OR NOT
+  IF(PRESENT(iNames)) THEN
+    DO it = 1, SIZE(iNames)
+      lerr = ALL(p /= iNames(it))
+      IF(fmsg('No isotopes class "'//TRIM(iNames(it))//'" found among tracers', modname, lerr)) RETURN
     END DO
-    iCla = iClasses
+    p = iNames; nbIso = SIZE(p)
   END IF
-  nbIso = SIZE(iCla)
-
-  !--- USE THE ARGUMENT "isot" TO STORE THE ISOTOPIC DATABASE OR THE LOCAL VECTOR "isotopes"
-  IF(PRESENT(isot)) THEN
-    ALLOCATE(    isot(nbIso))
-  ELSE
-    IF(ALLOCATED(isotopes)) DEALLOCATE(isotopes)
-    ALLOCATE(isotopes(nbIso))
-  END IF
+  IF(ALLOCATED(isotopes)) DEALLOCATE(isotopes)
+  ALLOCATE(isotopes(nbIso))
+
   IF(nbIso==0) RETURN                                                !=== NO ISOTOPES: FINISHED
 
   !--- ISOTOPES RELATED VARIABLES ; NULL OR EMPTY IF NO ISOTOPES
-  DO ic = 1, nbIso                                                   !--- Loop on isotopes classes
-    IF(     PRESENT(isot)) i1 => isot    (ic)
-    IF(.NOT.PRESENT(isot)) i1 => isotopes(ic)
-    iClass = iCla(ic)                                                !--- Current isotopes class name (parent tracer name)
-    i1%name = iClass
-
-    !=== Isotopes children of tracer "iClass": mask, names, number (same for each phase of "iClass")
-    ll = dType=='tracer' .AND. delPhase(parent) == iClass .AND. phase == 'g'
-    str1 = PACK(delPhase(tname), MASK = ll)                          !--- Effectively found isotopes of "iClass"
-    i1%niso = SIZE(str1)                                             !--- Number of "effectively found isotopes of "iname"
-    ALLOCATE(i1%keys(i1%niso))
-    DO it = 1, i1%niso; CALL addKey('name', str1(it), i1%keys(it)); END DO
-
-    !=== Geographic tagging tracers descending on tracer "iClass": mask, names, number
-    ll = dType=='tag'    .AND. delPhase(gen0N) == iClass .AND. iGen == 2
-    i1%zone = PACK(strTail(tname, '_', .TRUE.), MASK = ll)           !--- Tagging zones names  for isotopes category "iname"
-    CALL strReduce(i1%zone)
-    i1%nzone = SIZE(i1%zone)                                         !--- Tagging zones number for isotopes category "iClass"
-
-    !=== Geographic tracers of the isotopes children of tracer "iClass" (same for each phase of "iClass")
+  isotopes(:)%parent = p
+  DO ic = 1, SIZE(p)                                                 !--- Loop on isotopes classes
+    i => isotopes(ic)
+    iname = i%parent                                                 !--- Current isotopes class name (parent tracer name)
+
+    !=== Isotopes children of tracer "iname": mask, names, number (same for each phase of "iname")
+    ll = dType=='tracer' .AND. delPhase(parent) == iname .AND. phase == 'g'
+    str = PACK(delPhase(tname), MASK = ll)                           !--- Effectively found isotopes of "iname"
+    i%niso = SIZE(str)                                               !--- Number of "effectively found isotopes of "iname"
+    ALLOCATE(i%keys(i%niso))
+    FORALL(it = 1:i%niso) i%keys(it)%name = str(it)
+
+    !=== Geographic tagging tracers descending on tracer "iname": mask, names, number
+    ll = dType=='tag'    .AND. delPhase(gen0N) == iname .AND. iGen == 2
+    i%zone = PACK(strTail(tname,'_',.TRUE.), MASK = ll)              !--- Tagging zones names  for isotopes category "iname"
+    CALL strReduce(i%zone)
+    i%nzone = SIZE(i%zone)                                           !--- Tagging zones number for isotopes category "iname"
+
+    !=== Geographic tracers of the isotopes children of tracer "iname" (same for each phase of "iname")
     !    NOTE: One might like to create a similar variable for 2nd generation tagging tracers (tagging the gen1 tracers)
-    str2 = PACK(delPhase(tname), MASK=ll)
-    CALL strReduce(str2)
-    i1%ntiso = i1%niso + SIZE(str2)                                  !--- Number of isotopes + their geographic tracers [ntiso]
-    ALLOCATE(i1%trac(i1%ntiso))
-    DO it =         1, i1%niso;  i1%trac(it) = str1(it);         END DO
-    DO it = i1%niso+1, i1%ntiso; i1%trac(it) = str2(it-i1%niso); END DO
-
-    !=== Phases for tracer "iClass"
-    i1%phase = ''
-    DO ip = 1, nphases; ph = known_phases(ip:ip); IF(ANY(tname == addPhase(iClass, ph))) i1%phase = TRIM(i1%phase)//ph; END DO
-    i1%nphas = LEN_TRIM(i1%phase)                                       !--- Equal to "nqo" for water
+    str = PACK(delPhase(tname), MASK=ll)
+    CALL strReduce(str)
+    i%ntiso = i%niso + SIZE(str)                                     !--- Number of isotopes + their geographic tracers [ntiso]
+    ALLOCATE(i%trac(i%ntiso))
+    FORALL(it = 1:i%niso) i%trac(it) = i%keys(it)%name
+    FORALL(it = i%niso+1:i%ntiso) i%trac(it) = str(it-i%niso)
+
+    !=== Phases for tracer "iname"
+    i%phase = ''
+    DO ip = 1, nphases; ph = known_phases(ip:ip); IF(strIdx(t%name,addPhase(iname, ph)) /= 0) i%phase = TRIM(i%phase)//ph; END DO
+    i%nphas = LEN_TRIM(i%phase)                                       !--- Equal to "nqo" for water
 
     !=== Tables giving the index in a table of effectively found items for each dynamical tracer (1<=iq<=nqtot)
-    DO iq = 1, SIZE(tracers)
-      ii = strIdx(i1%trac, strHead(delPhase(tname(iq)), '_', .TRUE.))
-      iz = strIdx(i1%zone, strTail(         tname(iq),  '_', .TRUE.))
-      ip =  INDEX(i1%phase,            TRIM(phase(iq)              ))
-      IF(delPhase(gen0N(iq)) /= iClass .OR. iGen(iq) == 0) CYCLE     !--- Only deal with tracers descending on "iClass"
-      CALL addKey('iso_iGroup',ic, k(iq))                            !--- Family       idx in list "isotopes(:)%name"
-      CALL addKey('iso_iName', ii, k(iq))                            !--- Isotope      idx in effective isotopes list
-      CALL addKey('iso_iZone', iz, k(iq))                            !--- Tagging zone idx in effective zones    list
-      CALL addKey('iso_iPhas', ip, k(iq))                            !--- Phase        idx in effective phases   list
-      IF(iGen(iq) /= 2) CALL addKey('iso_iZone', 0, k(iq))           !--- Skip possible generation 1 tagging tracers
+    DO iq = 1, SIZE(t)
+      t1 => tracers(iq)
+      IF(delPhase(t1%gen0Name)/=iname .OR. t1%iGeneration==0) CYCLE  !--- Only deal with tracers descending on "iname"
+      t1%iso_iGroup = ic                                             !--- Isotopes family       idx in list "isotopes(:)%parent"
+      t1%iso_iName  = strIdx(i%trac, strHead(delPhase(t1%name),'_',.TRUE.)) !--- Current isotope       idx in effective isotopes list
+      t1%iso_iZone  = strIdx(i%zone,          strTail(t1%name, '_',.TRUE.)) !--- Current isotope zone  idx in effective zones    list
+      t1%iso_iPhase =  INDEX(i%phase,TRIM(t1%phase))                 !--- Current isotope phase idx in effective phases   list
+      IF(t1%iGeneration /= 2) t1%iso_iZone = 0                       !--- Skip possible generation 1 tagging tracers
     END DO
 
     !=== Table used to get iq (index in dyn array, size nqtot) from the isotope and phase indexes ; the full isotopes list
     !    (including tagging tracers) is sorted this way:  iso1, iso2, ..., iso1_zone1, iso2_zone1, ..., iso1_zoneN, iso2_zoneN
-    i1%iqIsoPha = RESHAPE( [( (strIdx(tname,  addPhase(i1%trac(it),i1%phase(ip:ip))),         it=1, i1%ntiso), ip=1, i1%nphas)], &
-                         [i1%ntiso, i1%nphas] )
+    i%iqIsoPha = RESHAPE( [( (strIdx(t%name,  addPhase(i%trac(it),i%phase(ip:ip))),       it=1, i%ntiso), ip=1, i%nphas)], &
+                         [i%ntiso, i%nphas] )
     !=== Table used to get iq (index in dyn array, size nqtot) from the water and isotope and phase indexes ; the full isotopes list
     !    (including tagging tracers) is sorted this way:  iso1, iso2, ..., iso1_zone1, iso2_zone1, ..., iso1_zoneN, iso2_zoneN
-    i1%iqWIsoPha = RESHAPE( [( [strIdx(tname, addPhase('H2O',      i1%phase(ip:ip))), i1%iqIsoPha(:,ip)],      ip=1, i1%nphas)], &
-                         [1+i1%ntiso, i1%nphas] )
+    i%iqWIsoPha = RESHAPE( [( [strIdx(t%name,   addPhase('H2O',i%phase(ip:ip))), i%iqIsoPha(:,ip)], ip=1,i%nphas)], &
+                         [1+i%ntiso, i%nphas] )
     !=== Table used to get ix (index in tagging tracers isotopes list, size ntiso) from the zone and isotope indexes
-    i1%itZonIso = RESHAPE( [( (strIdx(i1%trac(:), TRIM(i1%trac(it))//'_'//TRIM(i1%zone(iz))), iz=1, i1%nzone), it=1, i1%niso )], &
-                         [i1%nzone, i1%niso] )
+    i%itZonIso = RESHAPE( [( (strIdx(i%trac(:), TRIM(i%trac(it))//'_'//TRIM(i%zone(iz))), iz=1, i%nzone), it=1, i%niso )], &
+                         [i%nzone, i%niso] )
   END DO
 
-  !=== READ PHYSICAL PARAMETERS FROM isoFile FILE (COMMENTED => DISABLED)
-!  IF(     PRESENT(isot)) lerr = readIsotopesFile(isoFile, isot)
-!  IF(.NOT.PRESENT(isot)) lerr = readIsotopesFile(isoFile, isotopes)
-!  IF(lerr) RETURN
+  !=== READ PHYSICAL PARAMETERS FROM isoFile FILE
+!  lerr = readIsotopesFile(isoFile, isotopes); IF(lerr) RETURN! on commente pour ne pas chercher isotopes_params.def
 
   !--- GET THE isoCheck ENTRY FROM THE *.DEF FILES (MIGHT BE CHANGED TO A CLASS-DEPENDANT KEYWORD)
@@ -1282,9 +1311,5 @@
 
   !=== SELECT WATER ISOTOPES CLASS OR, IF UNFOUND, THE FIRST ISOTOPES CLASS
-  IF(isoSelect('H2O', lVerbose=.TRUE.)) THEN
-    iH2O = ixIso
-  ELSE
-    lerr = isoSelect(1, lVerbose=.TRUE.)
-  END IF
+  IF(isoSelect('H2O', .TRUE.)) THEN; iH2O = ixIso; ELSE; lerr = isoSelect(1, .TRUE.); END IF
 
 CONTAINS
@@ -1294,18 +1319,18 @@
 !------------------------------------------------------------------------------------------------------------------------------
   INTEGER :: ix, it, ip, np, iz, nz, npha, nzon
+  TYPE(isot_type), POINTER :: i
   DO ix = 1, nbIso
-    IF(     PRESENT(isot)) i1 => isot    (ix)
-    IF(.NOT.PRESENT(isot)) i1 => isotopes(ix)
+    i => isotopes(ix)
     !--- Check whether each isotope and tagging isotopic tracer is present in the same number of phases
-    DO it = 1, i1%ntiso; npha = i1%nphas
-      np = SUM([(COUNT(tname(:) == addPhase(i1%trac(it), i1%phase(ip:ip))), ip=1, npha)])
+    DO it = 1, i%ntiso; npha = i%nphas
+      np = SUM([(COUNT(tracers(:)%name == addPhase(i%trac(it), i%phase(ip:ip))), ip=1, npha)])
       lerr = np /= npha
-      CALL msg(TRIM(int2str(np))//       ' phases instead of '//TRIM(int2str(npha))//' for '//TRIM(i1%trac(it)), modname, lerr)
+      CALL msg(TRIM(int2str(np))//' phases instead of '//TRIM(int2str(npha))//' for '//TRIM(i%trac(it)), modname, lerr)
       IF(lerr) RETURN
     END DO
-    DO it = 1, i1%niso; nzon = i1%nzone
-      nz = SUM([(COUNT(i1%trac == TRIM(i1%trac(it))//'_'//i1%zone(iz)), iz=1, nzon)])
+    DO it = 1, i%niso; nzon = i%nzone
+      nz = SUM([(COUNT(i%trac == TRIM(i%trac(it))//'_'//i%zone(iz)), iz=1, nzon)])
       lerr = nz /= nzon
-      CALL msg(TRIM(int2str(nz))//' tagging zones instead of '//TRIM(int2str(nzon))//' for '//TRIM(i1%trac(it)), modname, lerr)
+      CALL msg(TRIM(int2str(nz))//' tagging zones instead of '//TRIM(int2str(nzon))//' for '//TRIM(i%trac(it)), modname, lerr)
       IF(lerr) RETURN
     END DO
@@ -1320,43 +1345,37 @@
 !==============================================================================================================================
 !=== THE ROUTINE isoSelect IS USED TO SWITCH FROM AN ISOTOPE FAMILY TO ANOTHER: ISOTOPES DEPENDENT PARAMETERS ARE UPDATED
-!     Single generic "isoSelect" routine, using the predefined index of the class (fast version) or its name (first call).
-!==============================================================================================================================
-LOGICAL FUNCTION isoSelectByName(iClass, isot, lVerbose) RESULT(lerr)
+!     Single generic "isoSelect" routine, using the predefined index of the parent (fast version) or its name (first call).
+!==============================================================================================================================
+LOGICAL FUNCTION isoSelectByName(iName, lVerbose) RESULT(lerr)
    IMPLICIT NONE
-   CHARACTER(LEN=*),                  INTENT(IN) :: iClass
-   TYPE(isot_type), OPTIONAL, TARGET, INTENT(IN) :: isot(:)
-   LOGICAL,         OPTIONAL,         INTENT(IN) :: lVerbose
-   TYPE(isot_type), POINTER :: iso(:)
+   CHARACTER(LEN=*),  INTENT(IN) :: iName
+   LOGICAL, OPTIONAL, INTENT(IN) :: lVerbose
    INTEGER :: iIso
    LOGICAL :: lV
-   lV = .FALSE.;    IF(PRESENT(lVerbose)) lV = lVerbose
-   iso => isotopes; IF(PRESENT(isot))    iso => isot
-   iIso = strIdx(iso(:)%name, iClass)
+   lV = .FALSE.; IF(PRESENT(lVerbose)) lV = lVerbose
+   iIso = strIdx(isotopes(:)%parent, iName)
    lerr = iIso == 0
    IF(lerr) THEN
       niso = 0; ntiso = 0; nzone = 0; nphas = 0; isoCheck=.FALSE.
-      CALL msg('no isotope family named "'//TRIM(iClass)//'"', ll=lV)
+      CALL msg('no isotope family named "'//TRIM(iName)//'"', ll=lV)
       RETURN
    END IF
-   lerr = isoSelectByIndex(iIso, iso, lV)
+   lerr = isoSelectByIndex(iIso, lV)
 END FUNCTION isoSelectByName
 !==============================================================================================================================
-LOGICAL FUNCTION isoSelectByIndex(iIso, isot, lVerbose) RESULT(lerr)
+LOGICAL FUNCTION isoSelectByIndex(iIso, lVerbose) RESULT(lerr)
    IMPLICIT NONE
-   INTEGER,                           INTENT(IN)    :: iIso
-   TYPE(isot_type), TARGET, OPTIONAL, INTENT(INOUT) :: isot(:)
-   LOGICAL,                 OPTIONAL, INTENT(IN)    :: lVerbose
-   TYPE(isot_type), POINTER :: i(:)
+   INTEGER,           INTENT(IN) :: iIso
+   LOGICAL, OPTIONAL, INTENT(IN) :: lVerbose
    LOGICAL :: lV
-   lV = .FALSE.;  IF(PRESENT(lVerbose)) lV = lVerbose
-   i => isotopes; IF(PRESENT(isot))      i => isot
+   lv = .FALSE.; IF(PRESENT(lVerbose)) lv = lVerbose
    lerr = .FALSE.
    IF(iIso == ixIso) RETURN                                          !--- Nothing to do if the index is already OK
-   lerr = iIso<=0 .OR. iIso>SIZE(i)
+   lerr = iIso<=0 .OR. iIso>SIZE(isotopes)
    CALL msg('Inconsistent isotopes family index '//TRIM(int2str(iIso))//': should be > 0 and <= '&
-          //TRIM(int2str(SIZE(i)))//'"', ll = lerr .AND. lV)
+          //TRIM(int2str(SIZE(isotopes)))//'"', ll = lerr .AND. lV)
    IF(lerr) RETURN
    ixIso = iIso                                                      !--- Update currently selected family index
-   isotope  => i(ixIso)                                              !--- Select corresponding component
+   isotope  => isotopes(ixIso)                                       !--- Select corresponding component
    isoKeys  => isotope%keys;     niso     = isotope%niso
    isoName  => isotope%trac;     ntiso    = isotope%ntiso
@@ -1365,5 +1384,5 @@
    itZonIso => isotope%itZonIso; isoCheck = isotope%check
    iqIsoPha => isotope%iqIsoPha
-   iqWIsoPha=> isotope%iqWIsoPha
+   iqWIsoPha => isotope%iqWIsoPha
 END FUNCTION isoSelectByIndex
 !==============================================================================================================================
@@ -1509,19 +1528,17 @@
 !=== OVERWRITE THE KEYS OF THE TRACER NAMED "tr0" WITH THE VALUES FOUND IN THE *.def FILES, IF ANY. ===========================
 !==============================================================================================================================
-LOGICAL FUNCTION addKeysFromDef(t, tr0) RESULT(lerr)
-  TYPE(keys_type), ALLOCATABLE, INTENT(INOUT) :: t(:)
+SUBROUTINE addKeysFromDef(t, tr0)
+  TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: t(:)
   CHARACTER(LEN=*),             INTENT(IN)    :: tr0
 !------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:)
   CHARACTER(LEN=maxlen) :: val
   INTEGER               :: ik, jd
-  lerr = getKey('name', tname, t); IF(lerr) RETURN
-  jd = strIdx(tname(:), tr0)
+  jd = strIdx(t%name, tr0)
   IF(jd == 0) RETURN
-  DO ik = 1, SIZE(t(jd)%key)
-    CALL get_in(t(jd)%key(ik), val, '*none*')
-    IF(val /= '*none*') CALL addKey(t(jd)%key(ik), val, t(jd), .TRUE.)
+  DO ik = 1, SIZE(t(jd)%keys%key)
+    CALL get_in(t(jd)%keys%key(ik), val, '*none*')
+    IF(val /= '*none*') CALL addKey(t(jd)%keys%key(ik), val, t(jd)%keys, .TRUE.)
   END DO
-END FUNCTION addKeysFromDef
+END SUBROUTINE addKeysFromDef
 !==============================================================================================================================
 
@@ -1533,5 +1550,5 @@
   INTEGER,          INTENT(IN)    :: itr
   CHARACTER(LEN=*), INTENT(IN)    :: keyn(:)
-  TYPE(keys_type),  INTENT(INOUT) :: ky(:)
+  TYPE(trac_type),  INTENT(INOUT) :: ky(:)
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen), ALLOCATABLE :: k(:), v(:)
@@ -1539,12 +1556,12 @@
   INTEGER :: iky
   IF(itr<=0 .OR. itr>SIZE(ky, DIM=1)) RETURN                          !--- Index is out of range
-  ll = [( ALL(keyn/=ky(itr)%key(iky)), iky=1, SIZE(ky(itr)%key) )]
-  k = PACK(ky(itr)%key, MASK=ll); CALL MOVE_ALLOC(FROM=k, TO=ky(itr)%key)
-  v = PACK(ky(itr)%val, MASK=ll); CALL MOVE_ALLOC(FROM=v, TO=ky(itr)%val)
+  ll = [( ALL(keyn/=ky(itr)%keys%key(iky)), iky=1, SIZE(ky(itr)%keys%key) )]
+  k = PACK(ky(itr)%keys%key, MASK=ll); CALL MOVE_ALLOC(FROM=k, TO=ky(itr)%keys%key)
+  v = PACK(ky(itr)%keys%val, MASK=ll); CALL MOVE_ALLOC(FROM=v, TO=ky(itr)%keys%val)
 END SUBROUTINE delKey_1
 !==============================================================================================================================
 SUBROUTINE delKey(keyn, ky)
   CHARACTER(LEN=*), INTENT(IN)    :: keyn(:)
-  TYPE(keys_type),  INTENT(INOUT) :: ky(:)
+  TYPE(trac_type),  INTENT(INOUT) :: ky(:)
 !------------------------------------------------------------------------------------------------------------------------------
   INTEGER :: iky
@@ -1594,5 +1611,5 @@
 !=== TRY TO GET THE KEY NAMED "key" FOR THE "itr"th TRACER IN:                                                              ===
 !===  * ARGUMENT "ky" DATABASE IF SPECIFIED ; OTHERWISE:                                                                    ===
-!===  * IN INTERNAL TRACERS DATABASE "tracers(:)" (IF UNFOUND, IN INTERNAL ISOTOPES DATABASE "isotope%keys(:)")             ===
+!===  * IN INTERNAL TRACERS DATABASE "tracers(:)%keys" (IF UNFOUND, IN INTERNAL ISOTOPES DATABASE "isotope%keys(:)")        ===
 !=== THE RETURNED VALUE (STRING, AN INTEGER, A REAL OR A LOGICAL) CAN BE EITHER:                                            ===
 !===  * A SCALAR                                                                                                            ===
@@ -1660,5 +1677,5 @@
   lerr = .TRUE.
   IF(lerr .AND. PRESENT(ky))         val = fgetKey(ky)                                   !--- "ky"
-  IF(lerr .AND. ALLOCATED (tracers)) val = fgetKey(tracers(:))                           !--- "tracers"
+  IF(lerr .AND. ALLOCATED (tracers)) val = fgetKey(tracers(:)%keys)                      !--- "tracers"
   IF(lerr .AND. ASSOCIATED(isotope)) val = fgetKey(isotope%keys(:))                      !--- "isotope"
   IF(lerr .AND. PRESENT(def)) THEN
@@ -1765,5 +1782,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   val = str2int(svals)
-  lerr = ANY(val == -HUGE(1)) .AND. sval /= ''
+  lerr = ANY(val == -HUGE(1))
   s = 'key "'//TRIM(keyn)//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
   CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
@@ -1785,5 +1802,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   val = str2real(svals)
-  lerr = ANY(val == -HUGE(1.)) .AND. sval /= ''
+  lerr = ANY(val == -HUGE(1.))
   s = 'key "'//TRIM(keyn)//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
   CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
@@ -1806,5 +1823,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   ivals = str2bool(svals)
-  lerr = ANY(ivals == -1) .AND. sval /= ''
+  lerr = ANY(ivals == -1)
   s = 'key "'//TRIM(keyn)//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
   CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
@@ -1843,5 +1860,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   val = str2int(svals)
-  lerr = ANY(val == -HUGE(1)) .AND. sval /= ''
+  lerr = ANY(val == -HUGE(1))
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
   CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
@@ -1864,5 +1881,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   val = str2real(svals)
-  lerr = ANY(val == -HUGE(1.)) .AND. sval /= ''
+  lerr = ANY(val == -HUGE(1.))
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
   CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
@@ -1886,5 +1903,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   ivals = str2bool(svals)
-  lerr = ANY(ivals == -1) .AND. sval /= ''
+  lerr = ANY(ivals == -1)
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
   CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
